use crate::{Accounts, State};
use sqlx::{Pool, Sqlite};
use tide::{
  prelude::{json, Deserialize},
  Request,
};

pub mod account {
  use super::*;

  #[derive(Debug, Deserialize)]
  struct Auth {
    auth: String,
  }
  pub async fn get(req: Request<State>) -> tide::Result {
    let config = &req.state().config;

    if let Ok(auth) = req.query::<Auth>() {
      if auth.auth != config.auth_discord {
        return Ok(json!([]).into());
      }
    } else {
      return Ok(json!([]).into());
    };

    let db = &req.state().db;

    let result = get_wolves_mail(db).await;

    Ok(json!(result).into())
  }

  pub async fn get_wolves_mail(db: &Pool<Sqlite>) -> Vec<String> {
    let results = sqlx::query_as::<_, Accounts>(
      r#"
        SELECT *
        FROM accounts
        WHERE discord IS NOT NULL AND enabled = 1
        "#,
    )
    .fetch_all(db)
    .await
    .unwrap_or(vec![]);

    let mut result = vec![];

    for item in results {
      if let Some(discord) = item.discord {
        result.push(discord);
      }
    }

    result
  }
}
